diff -r df9e3cb79379 -r 1ccb99c08f27 libinterp/parse-tree/pt-jit.cc
--- a/libinterp/parse-tree/pt-jit.cc	Wed May 08 18:45:34 2019 -0700
+++ b/libinterp/parse-tree/pt-jit.cc	Fri May 31 16:09:22 2019 -0500
@@ -22,9 +22,6 @@
 
 // Author: Max Brister <max@2bass.com>
 
-#define __STDC_LIMIT_MACROS
-#define __STDC_CONSTANT_MACROS
-
 #if defined (HAVE_CONFIG_H)
 #  include "config.h"
 #endif
@@ -126,6 +123,9 @@
 #  include <llvm/Transforms/Scalar/GVN.h>
 #endif
 
+#include <llvm/Transforms/InstCombine/InstCombine.h>
+#include <llvm/Transforms/Utils.h>
+
 static bool Vdebug_jit = false;
 
 static bool Vjit_enable = false;
@@ -153,6 +153,8 @@
 
   // -------------------- jit_break_exception --------------------
 
+  // FIXME: Get rid of this. We should not be throwing for expected behavior.
+
   // jit_break is thrown whenever a branch we are converting has only breaks or
   // continues.  This is because all code that follows a break or continue
   // is dead.
@@ -161,9 +163,12 @@
 
   // -------------------- jit_convert --------------------
   jit_convert::jit_convert (tree& tee, jit_type *for_bounds)
-    : m_converting_function (false)
+      : m_frame (interpreter::the_interpreter ()
+                 ->get_call_stack ()
+                 .get_current_stack_frame ()),
+        m_converting_function (false)
   {
-    initialize (__get_current_scope__ ("jit_convert::jit_convert"));
+    initialize ();
 
     if (for_bounds)
       create_variable (next_for_bounds (false), for_bounds);
@@ -182,11 +187,11 @@
     m_block->append (m_factory.create<jit_branch> (m_final_block));
     m_blocks.push_back (m_final_block);
 
-    for (auto iter = m_vmap.begin (); iter != m_vmap.end (); ++iter)
+    for (variable_map::value_type& vpair : m_vmap)
       {
-        jit_variable *var = iter->second;
+        jit_variable *var = vpair.second;
         const std::string& name = var->name ();
-        if (name.size () && name[0] != '#')
+        if (! name.empty () && name[0] != '#')
           m_final_block->append (m_factory.create<jit_store_argument> (var));
       }
 
@@ -195,9 +200,12 @@
 
   jit_convert::jit_convert (octave_user_function& fcn,
                             const std::vector<jit_type *>& args)
-    : m_converting_function (true)
+      : m_frame (interpreter::the_interpreter ()
+                 ->get_call_stack ()
+                 .get_current_stack_frame ()),
+        m_converting_function (true)
   {
-    initialize (fcn.scope ());
+    initialize ();
 
     tree_parameter_list *plist = fcn.parameter_list ();
     tree_parameter_list *rlist = fcn.return_list ();
@@ -205,7 +213,7 @@
       throw jit_fail_exception ("varags not supported");
 
     if (rlist && (rlist->size () > 1 || rlist->takes_varargs ()))
-      throw jit_fail_exception ("multiple returns not supported");
+      throw jit_fail_exception ("Multiple returns not supported");
 
     if (plist)
       {
@@ -213,7 +221,7 @@
         for (size_t i = 0; i < args.size (); ++i, ++piter)
           {
             if (piter == plist->end ())
-              throw jit_fail_exception ("Too many parameter to function");
+              throw jit_fail_exception ("Too many parameters to function");
 
             tree_decl_elt *elt = *piter;
             std::string name = elt->name ();
@@ -237,7 +245,7 @@
             catch (const jit_break_exception&)
               { }
 
-            if (m_breaks.size () || m_continues.size ())
+            if (! m_breaks.empty () || ! m_continues.empty())
               throw jit_fail_exception ("break/continue not supported in "
                                         "anonymous functions");
 
@@ -275,15 +283,13 @@
 
     // FIXME: We should use live range analysis to delete variables where
     // needed.  For now we just delete everything at the end of the function.
-    for (auto iter = m_vmap.begin ();
-         iter != m_vmap.end ();
-         ++iter)
+    for (variable_map::value_type& iter : m_vmap)
       {
-        if (iter->second != return_value)
+        if (iter.second != return_value)
           {
             jit_call *call;
             call = m_factory.create<jit_call> (&jit_typeinfo::destroy,
-                                               iter->second);
+                                               iter.second);
             m_final_block->append (call);
           }
       }
@@ -418,7 +424,7 @@
   void
   jit_convert::visit_simple_for_command (tree_simple_for_command& cmd)
   {
-    // Note we do an initial check to see if the loop will run atleast once.
+    // Note we do an initial check to see if the loop will run at least once.
     // This allows us to get better type inference bounds on variables defined
     // and used only inside the for loop (e.g., the index variable)
 
@@ -560,9 +566,10 @@
   {
     if (ti.has_magic_end ())
       {
-        if (! m_end_context.size ())
+        if (m_end_context.empty ())
           throw jit_fail_exception ("Illegal end");
-        m_result = m_block->append (m_factory.create<jit_magic_end> (m_end_context));
+        m_result = m_block->append (
+            m_factory.create<jit_magic_end> (m_end_context));
       }
     else
       {
@@ -643,8 +650,8 @@
             m_blocks.push_back (body);
 
             jit_instruction *br = m_factory.create<jit_cond_branch> (check,
-                                                                     body,
-                                                                     entry_blocks[i + 1]);
+                                                           body,
+                                                           entry_blocks[i + 1]);
             m_block->append (br);
             m_block = body;
           }
@@ -820,13 +827,12 @@
     else
       {
         // stolen from tree_evaluator::visit_statement
-        bool do_bind_ans = false;
+        bool do_bind_ans;
 
         if (expr->is_identifier ())
           {
-            tree_identifier *id = dynamic_cast<tree_identifier *> (expr);
-
-            do_bind_ans = (! id->is_variable (m_scope.current_context ()));
+            tree_identifier *t_id = dynamic_cast<tree_identifier *> (expr);
+            do_bind_ans = ! m_frame.is_variable (t_id->symbol ());
           }
         else
           do_bind_ans = (! expr->is_assignment_expression ());
@@ -840,8 +846,8 @@
             // FIXME: ugly hack, we need to come up with a way to pass
             // nargout to visit_identifier
             const jit_operation& fn = jit_typeinfo::print_value ();
-            jit_const_string *name = m_factory.create<jit_const_string>
-              (expr->name ());
+            jit_const_string *name
+                = m_factory.create<jit_const_string> (expr->name ());
             m_block->append (m_factory.create<jit_call> (fn, name,
                                                          expr_result));
           }
@@ -851,9 +857,8 @@
   void
   jit_convert::visit_statement_list (tree_statement_list& lst)
   {
-    for (auto iter = lst.begin (); iter != lst.end(); ++iter)
+    for (tree_statement *elt : lst)
       {
-        tree_statement *elt = *iter;
         // jwe: Can this ever be null?
         assert (elt);
         elt->accept (*this);
@@ -894,7 +899,7 @@
     if (last->is_default_case ())
       has_otherwise = 1;
 
-    std::vector<jit_block *> entry_blocks (case_blocks_num+1 - has_otherwise);
+    std::vector<jit_block *> entry_blocks (case_blocks_num + 1 - has_otherwise);
 
     // the first entry point is always the actual block.  Afterward, new blocks
     // are created for every case and the otherwise branch
@@ -906,8 +911,8 @@
 
     // if there's no otherwise branch, the 'else' of the last branch
     // has to point to the tail
-    if (! has_otherwise)
-      entry_blocks[entry_blocks.size()-1] = tail;
+    if (!has_otherwise)
+      entry_blocks[entry_blocks.size () - 1] = tail;
 
     // each branch in the case statement will have different breaks/continues
     block_list current_breaks = m_breaks;
@@ -925,18 +930,19 @@
         assert (m_block);
 
         if (i)
-          m_blocks.push_back (entry_blocks[i]);  // first block already pushed
-
-        if (! twc->is_default_case ())
+          m_blocks.push_back (entry_blocks[i]); // first block already pushed
+
+        if (!twc->is_default_case ())
           {
             // compare result of switch expression with actual case label
             tree_expression *te = twc->case_label ();
             jit_value *label = visit (te);
-            assert(label);
-
-            const jit_operation& fn = jit_typeinfo::binary_op (octave_value::op_eq);
+            assert (label);
+
+            const jit_operation& fn
+                = jit_typeinfo::binary_op (octave_value::op_eq);
             jit_value *cond = create_checked (fn, value, label);
-            assert(cond);
+            assert (cond);
 
             jit_call *check = create_checked (&jit_typeinfo::logically_true,
                                               cond);
@@ -950,7 +956,7 @@
           }
 
         tree_statement_list *stmt_lst = twc->commands ();
-        assert(stmt_lst);
+        assert (stmt_lst);
 
         try
           {
@@ -971,13 +977,13 @@
     m_breaks.splice (m_breaks.end (), current_breaks);
     m_continues.splice (m_continues.end (), current_continues);
 
-    if (num_incoming || ! has_otherwise)
+    if (num_incoming || !has_otherwise)
       {
         m_blocks.push_back (tail);
         m_block = tail; // switch_tail
       }
     else
-      throw jit_break_exception ();   // every branch broke
+      throw jit_break_exception (); // every branch broke
   }
 
   void
@@ -1034,7 +1040,7 @@
 
     finish_breaks (tail, m_breaks);
 
-    if (! all_breaking || m_continues.size ())
+    if (!all_breaking || ! m_continues.empty())
       {
         jit_block *interrupt_check
           = m_factory.create<jit_block> ("interrupt_check");
@@ -1087,7 +1093,7 @@
 
     finish_breaks (tail, m_breaks);
 
-    if (! all_breaking || m_continues.size ())
+    if (! all_breaking || ! m_continues.empty ())
       {
         jit_block *interrupt_check
           = m_factory.create<jit_block> ("interrupt_check");
@@ -1119,9 +1125,8 @@
   }
 
   void
-  jit_convert::initialize (const symbol_scope& s)
+  jit_convert::initialize ()
   {
-    m_scope = s;
     m_iterator_count = 0;
     m_for_bounds_count = 0;
     m_short_count = 0;
@@ -1165,17 +1170,19 @@
     if (ret)
       return ret;
 
+    // FIXME: there is a better way of doing this...
     symbol_table& symtab = __get_symbol_table__ ("jit_convert::find_variable");
 
-    symbol_record record = m_scope.find_symbol (vname);
-    if (record.is_persistent () || record.is_global ())
+    symbol_record record = m_frame.lookup_symbol (vname);
+
+    if (m_frame.is_persistent (record) || m_frame.is_global (record))
       throw jit_fail_exception ("Persistent and global not yet supported");
 
     if (m_converting_function)
       return create_variable (vname, jit_typeinfo::get_any (), false);
     else
       {
-        octave_value val = record.varval (m_scope.current_context ());
+        octave_value val = m_frame.varval (record);
         if (val.is_undefined ())
           val = symtab.find_function (vname);
 
@@ -1200,7 +1207,8 @@
       }
     else
       {
-        jit_call *init = m_factory.create<jit_call> (&jit_typeinfo::create_undef);
+        jit_call *init
+            = m_factory.create<jit_call> (&jit_typeinfo::create_undef);
         jit_assign *assign = m_factory.create<jit_assign> (var, init);
         m_entry_block->prepend (assign);
         m_entry_block->prepend (init);
@@ -1236,7 +1244,7 @@
     if (! arg_list)
       throw jit_fail_exception ("null argument list");
 
-    if (arg_list->size () < 1)
+    if (arg_list->empty ())
       throw jit_fail_exception ("Empty arg_list");
 
     tree_expression *tree_object = exp.expression ();
@@ -1253,7 +1261,7 @@
 
     size_t narg = arg_list->size ();
     auto iter = arg_list->begin ();
-    bool have_extra = extra_arg;
+    bool have_extra = extra_arg != nullptr;
     std::vector<jit_value *> call_args (narg + 1 + have_extra);
     call_args[0] = object;
 
@@ -1272,14 +1280,14 @@
       call_args[call_args.size () - 1] = extra_arg;
 
     const jit_operation& fres = (lhs ? jit_typeinfo::paren_subsasgn ()
-                                 : jit_typeinfo::paren_subsref ());
+                                     : jit_typeinfo::paren_subsref ());
 
     return create_checked (fres, call_args);
   }
 
   jit_value *
-  jit_convert::do_assign (tree_expression *exp, jit_value *rhs, bool
-                          artificial)
+  jit_convert::do_assign (tree_expression *exp, jit_value *rhs,
+                          bool artificial)
   {
     if (! exp)
       throw jit_fail_exception ("NULL lhs in assign");
@@ -1300,8 +1308,8 @@
   }
 
   jit_value *
-  jit_convert::do_assign (const std::string& lhs, jit_value *rhs,
-                          bool print, bool artificial)
+  jit_convert::do_assign (const std::string& lhs, jit_value *rhs, bool print,
+                          bool artificial)
   {
     jit_variable *var = get_variable (lhs);
     jit_assign *assign = m_block->append (m_factory.create<jit_assign> (var,
@@ -1331,19 +1339,17 @@
   }
 
   void
-  jit_convert::finish_breaks (jit_block *dest, const block_list& lst)
+  jit_convert::finish_breaks (jit_block *dest, block_list& lst)
   {
-    for (auto iter = lst.begin (); iter != lst.end (); ++iter)
+    for (jit_block* br : lst)
       {
-        jit_block *b = *iter;
-        b->append (m_factory.create<jit_branch> (dest));
+        br->append (m_factory.create<jit_branch> (dest));
       }
   }
 
   // -------------------- jit_convert_llvm --------------------
   llvm::Function *
-  jit_convert_llvm::convert_loop (const jit_module& module,
-                                  const jit_block_list& blocks,
+  jit_convert_llvm::convert_loop (const jit_block_list& blocks,
                                   const std::list<jit_value *>& constants,
                                   const std::string& llvm_function_name)
   {
@@ -1352,11 +1358,10 @@
     // for now just init arguments from entry, later we will have to do
     // something more interesting
     jit_block *m_entry_block = blocks.front ();
-    for (auto iter = m_entry_block->begin ();
-         iter != m_entry_block->end (); ++iter)
+    for (jit_instruction *instr : *m_entry_block)
       if (jit_extract_argument *extract
-          = dynamic_cast<jit_extract_argument *> (*iter))
-        m_argument_vec.push_back (std::make_pair (extract->name (), true));
+          = dynamic_cast<jit_extract_argument *> (instr))
+        m_argument_vec.emplace_back (extract->name (), true);
 
     jit_type *any = jit_typeinfo::get_any ();
 
@@ -1366,7 +1371,7 @@
     ft = llvm::FunctionType::get (llvm::Type::getVoidTy (context),
                                   arg_type->getPointerTo (), false);
 
-    m_function = module.create_llvm_function (ft, llvm_function_name);
+    m_function = m_module.create_llvm_function (ft, llvm_function_name);
     try
       {
         m_prelude = llvm::BasicBlock::Create (context, "prelude", m_function);
@@ -1376,14 +1381,16 @@
         // octave_base_value** type
         llvm::Value *arg = &*(m_function->arg_begin ());
 
-        for (size_t i = 0; i < m_argument_vec.size (); ++i)
+        for (unsigned i = 0; i < m_argument_vec.size (); ++i)
           {
-#if defined (LLVM_IRBUILDER_CREATECONSTINBOUNDSGEP1_32_REQUIRES_TYPE)
+#if defined(LLVM_IRBUILDER_CREATECONSTINBOUNDSGEP1_32_REQUIRES_TYPE)
             // LLVM >= 3.7
-            llvm::Value *loaded_arg = builder.CreateConstInBoundsGEP1_32 (arg_type, arg, i);
+            llvm::Value *loaded_arg
+                = builder.CreateConstInBoundsGEP1_32 (arg_type, arg, i);
 #else
             // LLVM <= 3.6
-            llvm::Value *loaded_arg = builder.CreateConstInBoundsGEP1_32 (arg, i);
+            llvm::Value *loaded_arg
+                = builder.CreateConstInBoundsGEP1_32 (arg, i);
 #endif
             m_arguments[m_argument_vec[i].first] = loaded_arg;
           }
@@ -1395,13 +1402,11 @@
         m_function->eraseFromParent ();
         throw;
       }
-
     return m_function;
   }
 
   jit_function
-  jit_convert_llvm::convert_function (const jit_module& module,
-                                      const jit_block_list& blocks,
+  jit_convert_llvm::convert_function (const jit_block_list& blocks,
                                       const std::list<jit_value *>& constants,
                                       octave_user_function& fcn,
                                       const std::vector<jit_type *>& args)
@@ -1412,8 +1417,8 @@
     jit_return *ret = dynamic_cast<jit_return *> (m_final_block->back ());
     assert (ret);
 
-    m_creating = jit_function (&module, jit_convention::internal,
-                               "foobar", ret->result_type (), args);
+    m_creating = jit_function (&m_module, jit_convention::internal, "foobar",
+                               ret->result_type (), args);
     m_function = m_creating.to_llvm ();
 
     try
@@ -1449,37 +1454,34 @@
   jit_convert_llvm::convert (const jit_block_list& blocks,
                              const std::list<jit_value *>& constants)
   {
-    std::list<jit_block *>::const_iterator biter;
-    for (biter = blocks.begin (); biter != blocks.end (); ++biter)
+    for (jit_block *bl : blocks)
       {
-        jit_block *jblock = *biter;
-        llvm::BasicBlock *m_block = llvm::BasicBlock::Create (context,
-                                                            jblock->name (),
-                                                            m_function);
-        jblock->stash_llvm (m_block);
+        llvm::BasicBlock *m_block
+            = llvm::BasicBlock::Create (context, bl->name (), m_function);
+        bl->stash_llvm (m_block);
       }
 
     jit_block *first = *blocks.begin ();
     builder.CreateBr (first->to_llvm ());
 
     // constants aren't in the IR, we visit those first
-    for (auto iter = constants.begin (); iter != constants.end (); ++iter)
-      if (! isa<jit_instruction> (*iter))
-        visit (*iter);
+    for (jit_value *c : constants)
+      if (! isa<jit_instruction> (c))
+        visit (c);
 
     // convert all instructions
-    for (biter = blocks.begin (); biter != blocks.end (); ++biter)
-      visit (*biter);
+    for(jit_block *bl : blocks)
+      visit (bl);
 
     // now finish phi nodes
-    for (biter = blocks.begin (); biter != blocks.end (); ++biter)
+    for (jit_block *bl : blocks)
       {
-        jit_block& m_block = **biter;
-        for (auto piter = m_block.begin ();
-             piter != m_block.end () && isa<jit_phi> (*piter); ++piter)
+        for (jit_instruction *instr : *bl)
           {
-            jit_instruction *phi = *piter;
-            finish_phi (static_cast<jit_phi *> (phi));
+            if (jit_phi *phi_node = dynamic_cast<jit_phi *>(instr))
+              finish_phi (phi_node);
+            else
+              break;
           }
       }
   }
@@ -1523,7 +1525,8 @@
     cc.stash_llvm (jit_typeinfo::create_complex (real, imag));
   }
 
-  void jit_convert_llvm::visit (jit_const_index& ci)
+  void
+  jit_convert_llvm::visit (jit_const_index& ci)
   {
     ci.stash_llvm (llvm::ConstantInt::get (ci.type_llvm (), ci.value ()));
   }
@@ -1531,20 +1534,19 @@
   void
   jit_convert_llvm::visit (jit_const_range& cr)
   {
-    llvm::StructType *stype = llvm::cast<llvm::StructType>(cr.type_llvm ());
+    llvm::StructType *stype = llvm::cast<llvm::StructType> (cr.type_llvm ());
     llvm::Type *scalar_t = jit_typeinfo::get_scalar_llvm ();
     llvm::Type *idx = jit_typeinfo::get_index_llvm ();
     const jit_range& rng = cr.value ();
 
-    llvm::Constant *constants[4];
-    constants[0] = llvm::ConstantFP::get (scalar_t, rng.m_base);
-    constants[1] = llvm::ConstantFP::get (scalar_t, rng.m_limit);
-    constants[2] = llvm::ConstantFP::get (scalar_t, rng.m_inc);
-    constants[3] = llvm::ConstantInt::get (idx, rng.m_nelem);
-
-    llvm::Value *as_llvm;
-    as_llvm = llvm::ConstantStruct::get (stype,
-                                         llvm::makeArrayRef (constants, 4));
+    llvm::ArrayRef<llvm::Constant *> constants{
+      llvm::ConstantFP::get (scalar_t, rng.m_base),
+      llvm::ConstantFP::get (scalar_t, rng.m_limit),
+      llvm::ConstantFP::get (scalar_t, rng.m_inc),
+      llvm::ConstantInt::get (idx, rng.m_nelem)
+    };
+
+    llvm::Value *as_llvm = llvm::ConstantStruct::get (stype, constants);
     cr.stash_llvm (as_llvm);
   }
 
@@ -1553,8 +1555,8 @@
   {
     llvm::BasicBlock *m_block = b.to_llvm ();
     builder.SetInsertPoint (m_block);
-    for (auto iter = b.begin (); iter != b.end (); ++iter)
-      visit (*iter);
+    for (jit_instruction *instr : b)
+      visit (instr);
   }
 
   void
@@ -1582,7 +1584,7 @@
     for (size_t i = 0; i < args.size (); ++i)
       args[i] = call.argument (i);
 
-    llvm::Value *ret = ol.call (builder, args);
+    llvm::Value *ret = ol.call (m_module, builder, args);
     call.stash_llvm (ret);
   }
 
@@ -1599,7 +1601,7 @@
         arg = builder.CreateLoad (arg);
 
         const jit_function& ol = extract.overload ();
-        extract.stash_llvm (ol.call (builder, arg));
+        extract.stash_llvm (ol.call (m_module, builder, arg));
       }
   }
 
@@ -1607,7 +1609,7 @@
   jit_convert_llvm::visit (jit_store_argument& store)
   {
     const jit_function& ol = store.overload ();
-    llvm::Value *arg_value = ol.call (builder, store.result ());
+    llvm::Value *arg_value = ol.call (m_module, builder, store.result ());
     llvm::Value *arg = m_arguments[store.name ()];
     store.stash_llvm (builder.CreateStore (arg_value, arg));
   }
@@ -1681,7 +1683,7 @@
       {
         const jit_function& ol = jit_typeinfo::get_release (overwrite->type ());
         if (ol.valid ())
-          ol.call (builder, overwrite);
+          ol.call (m_module, builder, overwrite);
       }
   }
 
@@ -1695,7 +1697,7 @@
     const jit_function& ol = me.overload ();
 
     jit_magic_end::context ctx = me.resolve_context ();
-    llvm::Value *ret = ol.call (builder, ctx.m_value, ctx.m_index,
+    llvm::Value *ret = ol.call (m_module, builder, ctx.m_value, ctx.m_index,
                                 ctx.m_count);
     me.stash_llvm (ret);
   }
@@ -1712,15 +1714,15 @@
 
     // initialize the worklist to instructions derived from constants
     const std::list<jit_value *>& constants = m_factory.constants ();
-    for (auto iter = constants.begin (); iter != constants.end (); ++iter)
-      append_users (*iter);
+    for (jit_value *c : constants)
+      append_users (c);
 
     // the entry block terminator may be a regular branch statement
     if (entry_block ().terminator ())
       push_worklist (entry_block ().terminator ());
 
     // FIXME: Describe algorithm here
-    while (m_worklist.size ())
+    while (! m_worklist.empty ())
       {
         jit_instruction *next = m_worklist.front ();
         m_worklist.pop_front ();
@@ -1777,26 +1779,26 @@
     entry_block ().create_dom_tree ();
 
     // insert phi nodes where needed, this is done on a per variable basis
-    for (auto iter = m_vmap.cbegin (); iter != m_vmap.cend (); ++iter)
+    for (const variable_map::value_type& vpair : m_vmap)
       {
         jit_block::df_set visited, added_phi;
         std::list<jit_block *> ssa_worklist;
-        iter->second->use_blocks (visited);
+        vpair.second->use_blocks (visited);
         ssa_worklist.insert (ssa_worklist.begin (), visited.begin (),
                              visited.end ());
 
-        while (ssa_worklist.size ())
+        while (! ssa_worklist.empty ())
           {
-            jit_block *b = ssa_worklist.front ();
+            jit_block *bl = ssa_worklist.front ();
             ssa_worklist.pop_front ();
 
-            for (auto diter = b->df_begin (); diter != b->df_end (); ++diter)
+            for (auto diter = bl->df_begin (); diter != bl->df_end (); ++diter)
               {
                 jit_block *dblock = *diter;
                 if (! added_phi.count (dblock))
                   {
-                    jit_phi *phi = m_factory.create<jit_phi> (iter->second,
-                                                          dblock->use_count ());
+                    jit_phi *phi = m_factory.create<jit_phi> (vpair.second,
+                                                         dblock->use_count ());
                     dblock->prepend (phi);
                     added_phi.insert (dblock);
                   }
@@ -1820,9 +1822,8 @@
       return;
 
     // replace variables with their current SSA value
-    for (auto iter = ablock.begin (); iter != ablock.end (); ++iter)
+    for (jit_instruction *instr : ablock)
       {
-        jit_instruction *instr = *iter;
         instr->construct_ssa ();
         instr->push_variable ();
       }
@@ -1832,7 +1833,7 @@
       {
         jit_block *finish = ablock.successor (i);
 
-        for (auto  iter = finish->begin ();
+        for (auto iter = finish->begin ();
              iter != finish->end () && isa<jit_phi> (*iter);)
           {
             jit_phi *phi = static_cast<jit_phi *> (*iter);
@@ -1845,8 +1846,8 @@
               {
                 // temporaries may have extraneous phi nodes which can be
                 // removed
-                assert (! phi->use_count ());
-                assert (var->name ().size () && var->name ()[0] == '#');
+                assert (!phi->use_count ());
+                assert (! var->name ().empty () && var->name ()[0] == '#');
                 phi->remove ();
               }
           }
@@ -1862,13 +1863,12 @@
   jit_infer::place_releases (void)
   {
     std::set<jit_value *> temporaries;
-    for (auto iter = m_blocks.begin (); iter != m_blocks.end (); ++iter)
+    for (jit_block *block : m_blocks)
       {
-        jit_block& ablock = **iter;
-        if (ablock.id () != jit_block::NO_ID)
+        if (block->id () != jit_block::NO_ID)
           {
-            release_temp (ablock, temporaries);
-            release_dead_phi (ablock);
+            release_temp (*block, temporaries);
+            release_dead_phi (*block);
           }
       }
   }
@@ -1876,7 +1876,7 @@
   void
   jit_infer::push_worklist (jit_instruction *instr)
   {
-    if (! instr->in_worklist ())
+    if (!instr->in_worklist ())
       {
         instr->stash_in_worklist (true);
         m_worklist.push_back (instr);
@@ -1963,7 +1963,7 @@
                 split->insert_before (term, release);
               }
 
-            phi->replace_with (0);
+            phi->replace_with (nullptr);
             phi->remove ();
           }
       }
@@ -2004,7 +2004,7 @@
           }
       }
 
-    if (! temp.size () || ! isa<jit_error_check> (ablock.terminator ()))
+    if (temp.empty () || ! isa<jit_error_check> (ablock.terminator ()))
       return;
 
     // FIXME: If we support try/catch or unwind_protect final_block
@@ -2012,9 +2012,8 @@
     jit_block *split = ablock.maybe_split (m_factory, m_blocks,
                                            final_block ());
     jit_terminator *term = split->terminator ();
-    for (auto iter = temp.cbegin (); iter != temp.cend (); ++iter)
+    for (jit_value *value : temp)
       {
-        jit_value *value = *iter;
         jit_call *release
           = m_factory.create<jit_call> (&jit_typeinfo::release, value);
         split->insert_before (term, release);
@@ -2025,12 +2024,15 @@
   void
   jit_infer::simplify_phi (void)
   {
-    for (auto biter = m_blocks.begin (); biter != m_blocks.end (); ++biter)
+    for (jit_block *block : m_blocks)
       {
-        jit_block &ablock = **biter;
-        for (auto iter = ablock.begin ();
-             iter != ablock.end () && isa<jit_phi> (*iter); ++iter)
-          simplify_phi (*static_cast<jit_phi *> (*iter));
+        for (jit_instruction *instr : *block)
+          {
+            if (jit_phi *phi_node = dynamic_cast<jit_phi *>(instr))
+              simplify_phi (*phi_node);
+            else
+              break;
+          }
       }
   }
 
@@ -2060,7 +2062,6 @@
       }
   }
 
-
   // ---------------- jit_memory_manager ------------------
 
   // A simple memory manager for our LLVM engines,
@@ -2068,25 +2069,26 @@
 
   class jit_memory_manager : public llvm::SectionMemoryManager
   {
+  public:
+    jit_memory_manager () = default;
+    virtual ~jit_memory_manager () = default;
+
     jit_memory_manager (const jit_memory_manager&) = delete;
     void operator= (const jit_memory_manager&) = delete;
-  public:
-    jit_memory_manager () { }
-    virtual ~jit_memory_manager () { }
 
     // The Kaleidoscope example in LLVM 3.8 indicates that
     // getPointerToNamedFunction has to be overloaded, but actually it is
     // getSymbolAddress that must be overloaded.
-    virtual uint64_t getSymbolAddress (const std::string &name);
+    virtual uint64_t getSymbolAddress (const std::string& name);
 
     // Is it still useful to overload getPointerToNamedFunction to support
     // some older version of LLVM?  Are there others virtual functions
     // that must be overloaded?
-    virtual void* getPointerToNamedFunction (const std::string& name, bool
-                                             abort_on_failure);
+    virtual void *getPointerToNamedFunction (const std::string& name,
+                                             bool abort_on_failure);
   };
 
-  void*
+  void *
   jit_memory_manager::getPointerToNamedFunction (const std::string& name,
                                                  bool abort_on_failure)
   {
@@ -2098,27 +2100,32 @@
 
     pfn = tree_jit::getPointerToNamedFunction (name);
     if ((pfn == nullptr) && abort_on_failure)
-      llvm::report_fatal_error ("Program used external function '" + name +
-                                "' which could not be resolved!");
+      llvm::report_fatal_error ("Program used external function '" + name
+                                + "' which could not be resolved!");
     return pfn;
   }
 
   uint64_t
-  jit_memory_manager::getSymbolAddress (const std::string &name)
+  jit_memory_manager::getSymbolAddress (const std::string& name)
   {
-    uint64_t addr = llvm::SectionMemoryManager::getSymbolAddress (name);
-    if (addr)
-      return addr;
-
+    uint64_t addr;
+
+    // FIXME: Not sure why this doesn't work... It retrieves an incorrect
+    // address when trying to resolve `sin`. My best guess is that it's
+    // actually resolving to an llvm internal function named `sin`.
+    //    uint64_t addr = llvm::SectionMemoryManager::getSymbolAddress (name);
+    //    if (addr)
+    //      return addr;
+
+    // Less magic if we do it this way anyway
     addr = tree_jit::getSymbolAddress (name);
     if (addr == 0)
-      llvm::report_fatal_error ("Program used extern function '" + name +
-                                "' which could not be resolved!");
+      llvm::report_fatal_error ("Program used external function '" + name
+                                + "' which could not be resolved!");
 
     return addr;
   }
 
-
   // -------------------- tree_jit --------------------
 
   bool tree_jit::initialized = false;
@@ -2129,8 +2136,7 @@
   int tree_jit::next_function_number = 0;
   int tree_jit::next_module_number = 0;
 
-  tree_jit::tree_jit (void)
-    : target_machine (nullptr)
+  tree_jit::tree_jit (void) : target_machine (nullptr)
   {
     // target_machine will be truly initialized by tree_jit::do_initialize ()
   }
@@ -2143,7 +2149,7 @@
   tree_jit&
   tree_jit::instance (void)
   {
-    static tree_jit ret;  // singleton instance of tree_jit
+    static tree_jit ret; // singleton instance of tree_jit
 
     if (! initialized)
       // Try to initialize the singleton instance
